! O'Mega scattering amplitudes for the processes
!
!   allowed:
!
!     A A -> W+ W-
!
!   forbidden:
!
!
! in minimal electroweak standard model in unitarity gauge
!
module omega_amplitude_aaww_ac
  use omega_kinds
  use omega95
  use omega_parameters
  implicit none
  private
  public :: amplitude, amplitude_f, amplitude_1, amplitude_2
  public :: amplitude_nonzero, amplitude_f_nonzero, amplitude_1_nonzero, &
    amplitude_2_nonzero
  public :: spin_sum_sqme, spin_sum_sqme_1, sum_sqme
  public :: spin_sum_sqme_nonzero, spin_sum_sqme_1_nonzero, sum_sqme_nonzero
  public :: scatter, scatter_diagonal, scatter_nonzero, &
    scatter_diagonal_nonzero
  public :: allocate_zero
  interface allocate_zero
     module procedure allocate_zero_1, allocate_zero_2
  end interface
  public :: allocate_zero_1, allocate_zero_2
  public :: number_particles, number_particles_in, number_particles_out
  public :: multiplicities, multiplicities_in, multiplicities_out
  public :: symmetry
  public :: number_spin_states, number_spin_states_in, number_spin_states_out, &
    spin_states, spin_states_in, spin_states_out
  public :: number_flavor_states, number_flavor_states_in, &
    number_flavor_states_out, flavor_states, &
    flavor_states_in, flavor_states_out
  public :: number_flavor_zeros, number_flavor_zeros_in, &
    number_flavor_zeros_out, flavor_zeros, flavor_zeros_in, flavor_zeros_out
  public :: create, reset, destroy
  ! DON'T EVEN THINK of removing the following!
  ! If the compiler complains about undeclared
  ! or undefined variables, you are compiling
  ! against an incompatible omega95 module!
  integer, dimension(6), parameter, private :: require = &
    (/ omega_spinors_2003_03_A, omega_spinor_cpls_2003_03_A, &
       omega_vectors_2003_03_A, omega_polarizations_2003_03_A, &
       omega_couplings_2003_03_A, omega_utils_2003_03_A /)

  integer, dimension(4), parameter, private :: s0001 = (/ -1, -1, -1, -1 /)
  integer, dimension(4), parameter, private :: s0002 = (/ -1, -1, -1,  0 /)
  integer, dimension(4), parameter, private :: s0003 = (/ -1, -1, -1,  1 /)
  integer, dimension(4), parameter, private :: s0004 = (/ -1, -1,  0, -1 /)
  integer, dimension(4), parameter, private :: s0005 = (/ -1, -1,  0,  0 /)
  integer, dimension(4), parameter, private :: s0006 = (/ -1, -1,  0,  1 /)
  integer, dimension(4), parameter, private :: s0007 = (/ -1, -1,  1, -1 /)
  integer, dimension(4), parameter, private :: s0008 = (/ -1, -1,  1,  0 /)
  integer, dimension(4), parameter, private :: s0009 = (/ -1, -1,  1,  1 /)
  integer, dimension(4), parameter, private :: s0010 = (/ -1,  1, -1, -1 /)
  integer, dimension(4), parameter, private :: s0011 = (/ -1,  1, -1,  0 /)
  integer, dimension(4), parameter, private :: s0012 = (/ -1,  1, -1,  1 /)
  integer, dimension(4), parameter, private :: s0013 = (/ -1,  1,  0, -1 /)
  integer, dimension(4), parameter, private :: s0014 = (/ -1,  1,  0,  0 /)
  integer, dimension(4), parameter, private :: s0015 = (/ -1,  1,  0,  1 /)
  integer, dimension(4), parameter, private :: s0016 = (/ -1,  1,  1, -1 /)
  integer, dimension(4), parameter, private :: s0017 = (/ -1,  1,  1,  0 /)
  integer, dimension(4), parameter, private :: s0018 = (/ -1,  1,  1,  1 /)
  integer, dimension(4), parameter, private :: s0019 = (/  1, -1, -1, -1 /)
  integer, dimension(4), parameter, private :: s0020 = (/  1, -1, -1,  0 /)
  integer, dimension(4), parameter, private :: s0021 = (/  1, -1, -1,  1 /)
  integer, dimension(4), parameter, private :: s0022 = (/  1, -1,  0, -1 /)
  integer, dimension(4), parameter, private :: s0023 = (/  1, -1,  0,  0 /)
  integer, dimension(4), parameter, private :: s0024 = (/  1, -1,  0,  1 /)
  integer, dimension(4), parameter, private :: s0025 = (/  1, -1,  1, -1 /)
  integer, dimension(4), parameter, private :: s0026 = (/  1, -1,  1,  0 /)
  integer, dimension(4), parameter, private :: s0027 = (/  1, -1,  1,  1 /)
  integer, dimension(4), parameter, private :: s0028 = (/  1,  1, -1, -1 /)
  integer, dimension(4), parameter, private :: s0029 = (/  1,  1, -1,  0 /)
  integer, dimension(4), parameter, private :: s0030 = (/  1,  1, -1,  1 /)
  integer, dimension(4), parameter, private :: s0031 = (/  1,  1,  0, -1 /)
  integer, dimension(4), parameter, private :: s0032 = (/  1,  1,  0,  0 /)
  integer, dimension(4), parameter, private :: s0033 = (/  1,  1,  0,  1 /)
  integer, dimension(4), parameter, private :: s0034 = (/  1,  1,  1, -1 /)
  integer, dimension(4), parameter, private :: s0035 = (/  1,  1,  1,  0 /)
  integer, dimension(4), parameter, private :: s0036 = (/  1,  1,  1,  1 /)
  integer, dimension(4,36), parameter, private :: table_spin_states = &
    reshape ( (/ s0001, s0002, s0003, s0004, s0005, s0006, s0007, s0008, s0009, &
    s0010, s0011, s0012, s0013, s0014, s0015, s0016, s0017, s0018, s0019, &
    s0020, s0021, s0022, s0023, s0024, s0025, s0026, s0027, s0028, s0029, &
    s0030, s0031, s0032, s0033, s0034, s0035, s0036 /), (/ 4, 36 /) )
  integer, dimension(2), parameter, private :: si0001 = (/ -1, -1 /)
  integer, dimension(2), parameter, private :: si0002 = (/ -1,  1 /)
  integer, dimension(2), parameter, private :: si0003 = (/  1, -1 /)
  integer, dimension(2), parameter, private :: si0004 = (/  1,  1 /)
  integer, dimension(2,4), parameter, private :: table_spin_states_in = &
    reshape ( (/ si0001, si0002, si0003, si0004 /), (/ 2, 4 /) )
  integer, dimension(2), parameter, private :: so0001 = (/ -1, -1 /)
  integer, dimension(2), parameter, private :: so0002 = (/ -1,  0 /)
  integer, dimension(2), parameter, private :: so0003 = (/ -1,  1 /)
  integer, dimension(2), parameter, private :: so0004 = (/  0, -1 /)
  integer, dimension(2), parameter, private :: so0005 = (/  0,  0 /)
  integer, dimension(2), parameter, private :: so0006 = (/  0,  1 /)
  integer, dimension(2), parameter, private :: so0007 = (/  1, -1 /)
  integer, dimension(2), parameter, private :: so0008 = (/  1,  0 /)
  integer, dimension(2), parameter, private :: so0009 = (/  1,  1 /)
  integer, dimension(2,9), parameter, private :: table_spin_states_out = &
    reshape ( (/ so0001, so0002, so0003, so0004, so0005, so0006, so0007, &
    so0008, so0009 /), (/ 2, 9 /) )

  integer, dimension(4), parameter, private :: &
    f0001 = (/  22,  22,  24, -24 /) ! A A W+ W-
  integer, parameter, private :: f0001m = 1
  integer, dimension(4,1), parameter, private :: table_flavor_states = &
    reshape ( (/ f0001 /), (/ 4, 1 /) )
  integer, dimension(1), parameter, private :: table_flavor_states_mult = (/ &
    f0001m /)
  integer, dimension(4,0), private :: table_flavor_zeros
  integer, dimension(2), parameter, private :: fi0001 = (/  22,  22 /) ! A A
  integer, parameter, private :: fi0001m = 1
  integer, dimension(2,1), parameter, private :: table_flavor_states_in = &
    reshape ( (/ fi0001 /), (/ 2, 1 /) )
  integer, dimension(1), parameter, private :: table_flavor_states_in_mult = (/ &
    fi0001m /)
  integer, dimension(2,0), private :: table_flavor_zeros_in
  integer, dimension(2), parameter, private :: fo0001 = (/  24, -24 /) ! W+ W-
  integer, parameter, private :: fo0001m = 1
  integer, dimension(2,1), parameter, private :: table_flavor_states_out = &
    reshape ( (/ fo0001 /), (/ 2, 1 /) )
  integer, dimension(1), parameter, private :: table_flavor_states_out_mult = &
    (/ fo0001m /)
  integer, dimension(2,0), private :: table_flavor_zeros_out

  integer, dimension(1), private :: table_symmetry = (/   1 /)

contains

  subroutine allocate_zero_1 (zero)
    integer, dimension(:,:), pointer :: zero
    allocate (zero(size(table_spin_states,dim=2), &
                   size(table_flavor_states,dim=2)))
    zero = 0
  end subroutine allocate_zero_1

  subroutine allocate_zero_2 (zero)
    integer, dimension(:,:,:,:), pointer :: zero
    allocate(zero(size(table_spin_states_in,dim=2), &
                  size(table_flavor_states_in,dim=2), &
                  size(table_spin_states_out,dim=2), &
                  size(table_flavor_states_out,dim=2)))
    zero = 0
  end subroutine allocate_zero_2

  subroutine create ()
  end subroutine create
  subroutine reset ()
  end subroutine reset
  subroutine destroy ()
  end subroutine destroy

  pure function number_particles () result (n)
    integer :: n
    n = size (table_flavor_states, dim=1)
  end function number_particles
  pure function number_particles_in () result (n)
    integer :: n
    n = size (table_flavor_states_in, dim=1)
  end function number_particles_in
  pure function number_particles_out () result (n)
    integer :: n
    n = size (table_flavor_states_out, dim=1)
  end function number_particles_out

  pure function number_spin_states () result (n)
    integer :: n
    n = size (table_spin_states, dim=2)
  end function number_spin_states
  pure subroutine spin_states (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_spin_states
  end subroutine spin_states
  pure function number_spin_states_in () result (n)
    integer :: n
    n = size (table_spin_states_in, dim=2)
  end function number_spin_states_in
  pure subroutine spin_states_in (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_spin_states_in
  end subroutine spin_states_in
  pure function number_spin_states_out () result (n)
    integer :: n
    n = size (table_spin_states_out, dim=2)
  end function number_spin_states_out
  pure subroutine spin_states_out (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_spin_states_out
  end subroutine spin_states_out

  pure function number_flavor_states () result (n)
    integer :: n
    n = size (table_flavor_states, dim=2)
  end function number_flavor_states
  pure subroutine flavor_states (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_states
  end subroutine flavor_states
  pure function number_flavor_states_in () result (n)
    integer :: n
    n = size (table_flavor_states_in, dim=2)
  end function number_flavor_states_in
  pure subroutine flavor_states_in (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_states_in
  end subroutine flavor_states_in
  pure function number_flavor_states_out () result (n)
    integer :: n
    n = size (table_flavor_states_out, dim=2)
  end function number_flavor_states_out
  pure subroutine flavor_states_out (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_states_out
  end subroutine flavor_states_out

  pure function number_flavor_zeros () result (n)
    integer :: n
    n = size (table_flavor_zeros, dim=2)
  end function number_flavor_zeros
  pure subroutine flavor_zeros (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_zeros
  end subroutine flavor_zeros
  pure function number_flavor_zeros_in () result (n)
    integer :: n
    n = size (table_flavor_zeros_in, dim=2)
  end function number_flavor_zeros_in
  pure subroutine flavor_zeros_in (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_zeros_in
  end subroutine flavor_zeros_in
  pure function number_flavor_zeros_out () result (n)
    integer :: n
    n = size (table_flavor_zeros_out, dim=2)
  end function number_flavor_zeros_out
  pure subroutine flavor_zeros_out (a)
    integer, dimension(:,:), intent(inout) :: a
    a = table_flavor_zeros_out
  end subroutine flavor_zeros_out

  pure subroutine multiplicities (a)
    integer, dimension(:), intent(inout) :: a
    a = table_flavor_states_mult
  end subroutine multiplicities

  pure subroutine multiplicities_in (a)
    integer, dimension(:), intent(inout) :: a
    a = table_flavor_states_in_mult
  end subroutine multiplicities_in

  pure subroutine multiplicities_out (a)
    integer, dimension(:), intent(inout) :: a
    a = table_flavor_states_out_mult
  end subroutine multiplicities_out

  pure function symmetry (f) result (s)
    real(kind=omega_prec) :: s
    integer, dimension(:), intent(in) :: f
    integer :: n
    n = flavor_index (f)
    if (n == 0) then
      s = 0
    else
      s = sqrt (real (table_symmetry(n), kind=omega_prec))
    end if
  end function symmetry

  pure function spin_index (s) result (n)
    integer, dimension(:), intent(in) :: s
    integer :: n
    integer, dimension(4), parameter :: num_helicities = (/ 2, 2, 3, 3 /)
    integer :: j, p
    n = 1
    p = 1
    do j = size (num_helicities), 1, -1
      select case (num_helicities(j))
      case (3)
        n = n + p * (s(j) + 1) 
      case (2)
        n = n + p * (s(j) + 1) / 2
      end select
      p = p * num_helicities(j)
    end do
  end function spin_index

  pure function flavor_index (f) result (n)
    integer, dimension(:), intent(in) :: f
    integer :: n
    n = 0
    select case (f(1))
    case (22)
      select case (f(2))
      case (22)
        select case (f(3))
        case (24)
          select case (f(4))
          case (-24) ! A A -> W+ W-
            n = 1
          end select
        end select
      end select
    end select
  end function flavor_index

  pure function amplitude (k, s, f) result (amp)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: s, f
    complex(kind=omega_prec) :: amp
    amp = 0
    select case (f(1))
    case (22)
      select case (f(2))
      case (22)
        select case (f(3))
        case (24)
          select case (f(4))
          case (-24) ! A A -> W+ W-
            amp = aawpwm (k, s)
          end select
        end select
      end select
    end select
  end function amplitude

  pure function amplitude_1 (k, s, f) result (amp)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, intent(in) :: s, f
    complex(kind=omega_prec) :: amp
    select case (f)
    case (1) ! A A -> W+ W-
      amp = aawpwm (k, table_spin_states (:,s))
    case default
      amp = 0
    end select
  end function amplitude_1

  pure function amplitude_f (k, s, f) result (amp)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: s
    integer, intent(in) :: f
    complex(kind=omega_prec) :: amp
    select case (f)
    case (1) ! A A -> W+ W-
      amp = aawpwm (k, s)
    case default
      amp = 0
    end select
  end function amplitude_f

  pure function amplitude_2 (k, s_in, f_in, s_out, f_out) result (amp)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, intent(in) :: s_in, f_in, s_out, f_out
    complex(kind=omega_prec) :: amp
    integer, dimension(size(table_spin_states,dim=1)) :: s
    s(1:size(table_spin_states_in,dim=1)) = table_spin_states_in(:,s_in)
    s(size(table_spin_states_in,dim=1)+1:) = table_spin_states_out(:,s_out)
    amp = 0
    select case (f_in)
    case (1)
      select case (f_out)
      case (1) ! aa -> wpwm
        amp = aawpwm (k, s)
      end select
    end select
  end function amplitude_2

  pure subroutine scatter (k, rho_in, rho_out)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    complex(kind=omega_prec), dimension(:,:,:,:), intent(in) :: rho_in
    complex(kind=omega_prec), dimension(:,:,:,:), intent(inout) :: rho_out
    call omega_scatter (amplitude_2, k, rho_in, rho_out, &
              table_flavor_states_out_mult)
  end subroutine scatter

  pure subroutine scatter_diagonal (k, rho_in, rho_out)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    real(kind=omega_prec), dimension(:,:), intent(in) :: rho_in
    real(kind=omega_prec), dimension(:,:), intent(inout) :: rho_out
    call omega_scatter_diagonal (amplitude_2, k, rho_in, rho_out, &
              table_flavor_states_out_mult)
  end subroutine scatter_diagonal

  pure subroutine amplitude_nonzero (amp, k, s, f, zero, n)
    complex(kind=omega_prec), intent(out) :: amp
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: s, f
    integer, dimension(:,:), intent(inout) :: zero
    integer, intent(in) :: n
    call amplitude_1_nonzero &
      (amp, k, spin_index (s), flavor_index (f), zero, n)
  end subroutine amplitude_nonzero

  pure subroutine amplitude_1_nonzero (amp, k, s, f, zero, n)
    complex(kind=omega_prec), intent(out) :: amp
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, intent(in) :: s, f
    integer, dimension(:,:), intent(inout) :: zero
    integer, intent(in) :: n
    call omega_amplitude_1_nonzero (amplitude_1, amp, k, s, f, zero, n)
  end subroutine amplitude_1_nonzero

  pure subroutine amplitude_f_nonzero (amp, k, s, f, zero, n)
    complex(kind=omega_prec), intent(out) :: amp
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: s
    integer, intent(in) :: f
    integer, dimension(:,:), intent(inout) :: zero
    integer, intent(in) :: n
    call amplitude_1_nonzero (amp, k, spin_index (s), f, zero, n)
  end subroutine amplitude_f_nonzero

  pure subroutine amplitude_2_nonzero &
       (amp, k, s_in, f_in, s_out, f_out, zero, n)
    complex(kind=omega_prec), intent(out) :: amp
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, intent(in) :: s_in, f_in, s_out, f_out
    integer, dimension(:,:,:,:), intent(inout) :: zero
    integer, intent(in) :: n
    call omega_amplitude_2_nonzero (amplitude_2, amp, k, &
           s_in, f_in, s_out, f_out, zero, n)
  end subroutine amplitude_2_nonzero

  pure subroutine scatter_nonzero (k, rho_in, rho_out, zero, n)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    complex(kind=omega_prec), dimension(:,:,:,:), intent(in) :: rho_in
    complex(kind=omega_prec), dimension(:,:,:,:), intent(inout) :: rho_out
    integer, dimension(:,:,:,:), intent(inout) :: zero
    integer, intent(in) :: n
    call omega_scatter_nonzero (amplitude_2_nonzero, k, rho_in, rho_out, &
              table_flavor_states_out_mult, zero, n)
  end subroutine scatter_nonzero

  pure subroutine scatter_diagonal_nonzero (k, rho_in, rho_out, zero, n)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    real(kind=omega_prec), dimension(:,:), intent(in) :: rho_in
    real(kind=omega_prec), dimension(:,:), intent(inout) :: rho_out
    integer, dimension(:,:,:,:), intent(inout) :: zero
    integer, intent(in) :: n
    call omega_scatter_diagonal_nonzero (amplitude_2_nonzero, k, &
              rho_in, rho_out, table_flavor_states_out_mult, zero, n)
  end subroutine scatter_diagonal_nonzero

  pure function spin_sum_sqme (k, f, smask) result (amp2)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: f
    logical, dimension(:), intent(in), optional :: smask
    real(kind=omega_prec) :: amp2
    amp2 = spin_sum_sqme_1 (k, flavor_index (f), smask)
  end function spin_sum_sqme

  pure function spin_sum_sqme_1 (k, f, smask) result (amp2)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, intent(in) :: f
    logical, dimension(:), intent(in), optional :: smask
    real(kind=omega_prec) :: amp2
    amp2 = omega_spin_sum_sqme_1 (amplitude_1, k, f,  &
             size (table_spin_states, dim=2), smask)
  end function spin_sum_sqme_1

  pure function sum_sqme (k, smask, fmask) result (amp2)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    logical, dimension(:), intent(in), optional :: smask, fmask
    real(kind=omega_prec) :: amp2
    amp2 = omega_sum_sqme (amplitude_1, k, size (table_spin_states, dim=2), &
             size (table_flavor_states, dim=2), table_flavor_states_mult, &
             smask, fmask)
  end function sum_sqme

  pure subroutine spin_sum_sqme_nonzero (amp2, k, f, zero, n, smask)
    real(kind=omega_prec), intent(out) :: amp2
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: f
    integer, dimension(:,:), intent(inout) :: zero
    integer, intent(in) :: n
    logical, dimension(:), intent(in), optional :: smask
    call spin_sum_sqme_1_nonzero (amp2, k, flavor_index (f), zero, n, smask)
  end subroutine spin_sum_sqme_nonzero

  pure subroutine spin_sum_sqme_1_nonzero (amp2, k, f, zero, n, smask)
    real(kind=omega_prec), intent(out) :: amp2
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, intent(in) :: f
    integer, dimension(:,:), intent(inout) :: zero
    integer, intent(in) :: n
    logical, dimension(:), intent(in), optional :: smask
    call omega_spin_sum_sqme_1_nonzero (amplitude_1, amp2, k, f, zero, n, &
           smask);
  end subroutine spin_sum_sqme_1_nonzero

  pure subroutine sum_sqme_nonzero (amp2, k, zero, n, smask, fmask)
    real(kind=omega_prec), intent(out) :: amp2
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:,:), intent(inout) :: zero
    integer, intent(in) :: n
    logical, dimension(:), intent(in), optional :: smask, fmask
    call omega_sum_sqme_nonzero (amplitude_1, amp2, k, &
           table_flavor_states_mult, zero, n, smask, fmask)
  end subroutine sum_sqme_nonzero

  ! process: A A -> W+ W-
  pure function aawpwm (k, s) result (amp)
    real(kind=omega_prec), dimension(0:,:), intent(in) :: k
    integer, dimension(:), intent(in) :: s
    complex(kind=omega_prec) :: amp
    type(momentum) :: p1, p2, p3, p4
    type(vector) :: a_2, a_1, wp_4, wm_3
    complex(kind=omega_prec) :: h_12
    type(vector) :: wp_14, wm_13
    type(momentum) :: p12, p13, p14
    p1 = - k(:,1) ! incoming A
    p2 = - k(:,2) ! incoming A
    p3 =   k(:,3) ! outgoing W+
    p4 =   k(:,4) ! outgoing W-
    a_1 = eps (mass(22), - p1, s(1))
    a_2 = eps (mass(22), - p2, s(2))
    wm_3 = conjg (eps (mass(24), p3, s(3)))
    wp_4 = conjg (eps (mass(24), p4, s(4)))
    p12 = p1 + p2
    h_12 = pr_phi(p12,mass(25),wd_tl(p12,width(25)), &
       + (ghgaga)*((p1*a_2)*(p2*a_1) - (p1*p2)*(a_2*a_1)))
    p13 = p1 + p3
    wm_13 = pr_unitarity(p13,mass(24),wd_tl(p13,width(24)), &
       + tkv_vv((-ig1pkpg4a),a_1,p1,wm_3,p3) + tv_kvv((-ig1a),a_1,p1,wm_3,p3) &
       + tv_kvv(ig1pkmg4a,wm_3,p3,a_1,p1) + lv_kvv((-ig1mkpg4a),wm_3,p3,a_1) &
       + lkv_vv(ig1mkmg4a,a_1,p1,wm_3,p3) + t5v_kvv((-ik5a),a_1,p1,wm_3,p3) &
       + l5v_kvv((-rg5a),a_1,p1,wm_3) + kg_kgkg((-ila),wm_3,p3,a_1,p1) &
       + (-1)*kg_kg5kg((-il5a),a_1,p1,wm_3,p3))
    p14 = p1 + p4
    wp_14 = pr_unitarity(p14,mass(24),wd_tl(p14,width(24)), &
       + (-1)*tv_kvv((-ig1a),a_1,p1,wp_4,p4) &
       + tv_kvv((-ig1pkpg4a),wp_4,p4,a_1,p1) + tkv_vv(ig1pkmg4a,a_1,p1,wp_4,p4) &
       + lkv_vv((-ig1mkpg4a),a_1,p1,wp_4,p4) + lv_kvv(ig1mkmg4a,wp_4,p4,a_1) &
       + t5v_kvv((-ik5a),a_1,p1,wp_4,p4) + (-1)*l5v_kvv((-rg5a),a_1,p1,wp_4) &
       + kg_kgkg((-ila),a_1,p1,wp_4,p4) + kg_kg5kg((-il5a),a_1,p1,wp_4,p4))
    amp = 0
!    disable higgs  
!    amp = amp + h_12*( + ghww*(wm_3*wp_4))
    amp = amp + wm_13*( + kg_kg5kg((-il5a),a_2,p2,wp_4,p4) &
       + kg_kgkg((-ila),a_2,p2,wp_4,p4) + (-1)*l5v_kvv((-rg5a),a_2,p2,wp_4) &
       + t5v_kvv((-ik5a),a_2,p2,wp_4,p4) + lv_kvv(ig1mkmg4a,wp_4,p4,a_2) &
       + lkv_vv((-ig1mkpg4a),a_2,p2,wp_4,p4) &
       + tv_kvv((-ig1pkpg4a),wp_4,p4,a_2,p2) + tkv_vv(ig1pkmg4a,a_2,p2,wp_4,p4) &
       + (-1)*tv_kvv((-ig1a),a_2,p2,wp_4,p4))
    amp = amp + wp_14*( + (-1)*kg_kg5kg((-il5a),a_2,p2,wm_3,p3) &
       + kg_kgkg((-ila),wm_3,p3,a_2,p2) + l5v_kvv((-rg5a),a_2,p2,wm_3) &
       + t5v_kvv((-ik5a),a_2,p2,wm_3,p3) + lkv_vv(ig1mkmg4a,a_2,p2,wm_3,p3) &
       + lv_kvv((-ig1mkpg4a),wm_3,p3,a_2) + tkv_vv((-ig1pkpg4a),a_2,p2,wm_3,p3) &
       + tv_kvv(ig1pkmg4a,wm_3,p3,a_2,p2) + tv_kvv((-ig1a),a_2,p2,wm_3,p3))
    amp = amp + a_1*( - ((((-2)*gaaww)*(wm_3*wp_4))*a_2 &
      + ((gaaww)*(a_2*wm_3))*wp_4 + ((gaaww)*(a_2*wp_4))*wm_3))
    amp = - amp ! 2 vertices, 1 propagators
    ! unit symmetry factor
    ! unit color factor
    ! Number of external adjoints: 0
  end function aawpwm

end module omega_amplitude_aaww_ac
! O'Mega revision control information:
!    Models.SM:
!      minimal electroweak standard model in unitarity gauge
!      file: /home/sources/ohl/ml/omega/src/models.ml,v
!      revision: 1.105.8.3 checked in by ohl at 2006/05/15 08:40:04
!    Targets.Make_Fortran():
!      NB: non-gauge vector couplings are not available yet
!      file: /home/sources/ohl/ml/omega/src/targets.ml,v
!      revision: 1.170.4.4 checked in by ohl at 2006/05/15 08:36:40
!    Targets.Fortran_Fermions():
!      generates Fortran95 code for Dirac fermions
!      using revision 2000_10_A of module omega95
!      file: /home/sources/ohl/ml/omega/src/targets.ml,v
!      revision: 1.170.4.4 checked in by ohl at 2006/05/15 08:36:40
!    DAG.Graded():
!      Graded directed Acyclical Graph 
!      representing binary or n-ary trees
!      file: /home/sources/ohl/ml/omega/src/dAG.ml,v
!      revision: 1.33 checked in by ohl at 2004/06/22 09:30:18
!    Topology.Mixed23:
!      phi**3 + phi**4 topology
!      file: /home/sources/ohl/ml/omega/src/topology.ml,v
!      revision: 1.39 checked in by ohl at 2004/06/22 09:30:18
!    Momentum.Bits():
!      Finite disjoint sums of momenta
!      using bitfields as representation.
!      file: /home/sources/ohl/ml/omega/src/momentum.ml,v
!      revision: 1.16.10.1 checked in by ohl at 2005/11/06 21:14:35
!    Fusion.Make():
!      Fusions for arbitrary topologies
!      file: /home/sources/ohl/ml/omega/src/fusion.ml,v
!      revision: 1.108.8.3 checked in by ohl at 2006/05/15 08:30:41
