#include <stdio.h>
#include <stdlib.h>
#define DEBUG 0

/*
 __OMEGA_ME__ is defined from Makefile -D__OMEGA_ME__=0/1
*/ 
//#define __OMEGA_ME__ 0

// specify the usage of omega in Makefile
#ifdef __OMEGA_ME__
   extern double omega_interface_mp_get_spin_sum_sqme_1_(int *, double *, double *,
         double *, double *, double *, double *);
   extern double omega_interface_mp_testf_(double *, double *);
#endif
   

/*
 parameters: all are clear:
    _cutoff_scale means the scale cutoff - if < 0, no formfactor used
 */
void c_omega_wraper__(int *_aawwanom, double* _s, double * _t, double* _wmass, double* _d_kappa, double *_lambda,  double *_cutoff_scale, double* _amp2){

   if(DEBUG>99){
      double s          = *_s; 
      double t          = *_t; 
      double wmass      = *_wmass; 
      double d_kappa    = *_d_kappa; 
      double d_lambda    = *_lambda; 
      double cutoff_scale= *_cutoff_scale; 

      printf("wraper: s=%f: \n", s );
      printf("wraper: t=%f: \n", t );
      printf("cutoff_scale=%f: \n", cutoff_scale);
   }   

#if __OMEGA_ME__==1
   double amp2omega = omega_interface_mp_get_spin_sum_sqme_1_( _aawwanom, _s,_t,_wmass,
         _d_kappa, _lambda, _cutoff_scale);
 //     double amp2omega =   omega_interface_mp_testf_(_s, _t);
#else
   double amp2omega = -999;
   printf("omega_interface_c.c: O'Mega amplitude for aa->ww coupling was not linked!\n");
   printf("You have to compile FPMC with O'Mega setting OMEGA_ME=1 in Makefile\n");
   exit(1);
#endif

   *_amp2 = amp2omega;

} 
